<template>
  <div class="app-layout">
    <div class="app-layout__header">
      <menubar :model="items">
        <template #end>
          <div class="app-layout-end">
            <prime-button
              type="button"
              icon="pi pi-user"
              :label="user.email"
              aria-haspopup="true"
              aria-controls="overlay_menu"
              @click="toggle"
            />
            <prime-menu
              id="overlay_menu"
              ref="menu"
              :model="userOptions"
              :popup="true"
            />
          </div>
        </template>
      </menubar>
    </div>
    <slot />
  </div>
  <prime-toast position="bottom-right" />
  <prime-confirmation-dialog />
</template>

<script lang="ts">
import PrimeButton from 'primevue/button/Button.vue';
import PrimeMenu from 'primevue/menu/Menu.vue';
import Menubar from 'primevue/menubar/Menubar.vue';
import { defineComponent, PropType } from 'vue';
import { User } from '@/models/user';

export default defineComponent({
  name: 'app-layout',
  components: {
    Menubar,
    PrimeButton,
    PrimeMenu,
  },
  props: {
    user: { type: Object as PropType<User>, required: true },
  },
  emits: ['sign-out', 'edit-user', 'change-password'],
  computed: {
    items() {
      const items = [
        {
          label:'Главная',
          icon:'pi pi-fw pi-home',
          to: '/',
        },
      ];

      if (this.user.role > 1) {
        items.push({
          label:'Пользователи',
          icon:'pi pi-fw pi-user',
          to: '/users',
        });
      }
      return items;
    },
    userOptions() {
      return [
        {
          label: 'Настройки',
          icon: 'pi pi-user-edit',
          command: (): void => {
            this.$emit('edit-user');
          },
        },
        {
          label: 'Смена пароля',
          icon: 'pi pi-pencil',
          command: (): void => {
            this.$emit('change-password');
          },
        },
        {
          label: 'Выйти',
          icon: 'pi pi-sign-out',
          command: (): void => {
            this.$emit('sign-out');
          },
        },
      ];
    },
  },
  methods: {
    toggle(event: MouseEvent) {
      (this.$refs.menu as any).toggle(event);
    },
  },
});
</script>

<style lang="scss" scoped>
.app-layout {
  margin: auto;
  padding: 1rem;
  // max-width: 1920px;


  &__header {
    margin-bottom: 1rem;
  }
}

.app-layout-end {
  display: flex;
  align-items: center;

  & > *:not(:last-child) {
    margin-right: 10px;
  }
}
</style>
